#include <IRremote.h>
#include <TMRpcm.h>
#include <SD.h>
#include <SPI.h>
TMRpcm audio;
IRrecv irrecv(A1);
decode_results results;
int echo = 2;
int trig = 3;
int enA = 6;
int enB = 5; //need to be exchanged with in2
int in1 = A3;
int in2 = 10;
int in3 = 8;
int in4 = 7; 

int mic_pin = A0;
#define SD_ChipSelectPin 4
int times;
unsigned int sample;
TMRpcm tmrpcm;

void setup() {
  tmrpcm.speakerPin=9;
  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(trig, OUTPUT);
  pinMode(echo, INPUT);
  irrecv.enableIRIn();
  tmrpcm.setVolume(6);
  Serial.begin(9600);
  if(!SD.begin(SD_ChipSelectPin)){
    Serial.println("SD fail");
    return;
  }
  else{
    tmrpcm.play("one.wav");
  }
}
bool listening(){
  unsigned int peakToPeak = 0;   // peak-to-peak level
  unsigned int signalMax = 0;
  unsigned int signalMin = 1024;
  for(int i =1000; i>0; i--){
    sample = analogRead(A0);
    if (sample < 1024){
      if (sample > signalMax){
        signalMax = sample;  // save just the max levels
      }
      else if (sample < signalMin){
        signalMin = sample;  // save just the min levels
      }
    }
  }
  peakToPeak = signalMax - signalMin;
  double volts = (peakToPeak * 5.0) / 1024;  
  if(volts>3){
    return true;
  }
  else{
    return false;
  }
}
bool scan(){
  digitalWrite(trig, LOW);
  delayMicroseconds(2);
  digitalWrite(trig, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig, LOW);
  times = pulseIn(echo, HIGH);
  Serial.println("scanning");
  Serial.println(times);
  if(times<3000){
    return true;
  }
  else{
    return false;
  }
}
void onward(){
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  analogWrite(enA, 255);
  analogWrite(enB, 255);
}
void backward(){
  digitalWrite(in2, HIGH);
  digitalWrite(in1, LOW);
  digitalWrite(in4, HIGH);
  digitalWrite(in3, LOW);
  analogWrite(enA, 255);
  analogWrite(enB, 255);
}
void rightFront(){
  digitalWrite(in1, LOW);
  digitalWrite(in2, HIGH);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);
  analogWrite(enA, 70);
  analogWrite(enB, 150);
}
void leftBack(){ 
  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, HIGH);
  analogWrite(enA, 70);
  analogWrite(enB, 225);
}
void stoped(){
  analogWrite(enA, 0);
  analogWrite(enB, 0);
}
void one(){
  Serial.println("here");
  onward();
  //tmrpcm.play("sound1.wav");
  for(int x=0;x<1000;x++){ 
    scan();
    if(scan()==true){
      stoped();
      break;
    }
  }
  while(listening()!=true){
  }
  //tmrpcm.play("run.wav");
  leftBack();
  delay(5000);
  stoped();
  onward();
  for(int x=0;x<1000;x++){ 
    scan();
    if(scan()==true){
      break;
    }
  }
  stoped();
}
void playing(char fileName){
  tmrpcm.play(fileName);
  Serial.println("playing");
}
void record(int sampleRate){
  audio.startRecording("spy3.wav", 16000, mic_pin);
  delay(sampleRate);
  audio.stopRecording("spy3.wav");
  Serial.println("record succesfull");
}
void translateIR(){
  Serial.println(results.value, HEX);
  switch(results.value){
  case 0xFFA25D: Serial.println("turning"); leftBack(); delay(10000);stoped();break;
  case 0xFFE21D: Serial.println("FUNC/STOP"); break;
  case 0xFF629D: Serial.println("VOL+"); onward(); delay(3000);stoped();break;
  case 0xFF22DD: Serial.println("FAST BACK"); leftBack(); delay(3000);stoped();break;
  case 0xFF02FD: Serial.println("PAUSE");  tmrpcm.play("spy.wav");  break;
  case 0xFFC23D: Serial.println("FAST FORWARD");rightFront(); delay(3000);stoped();break;
  case 0xFFE01F: Serial.println("DOWN");    break;
  case 0xFFA857: Serial.println("VOL-");    backward(); delay(1000);stoped();break;
  case 0xFF906F: Serial.println("UP");    break;
  case 0xFF9867: Serial.println("EQ");    break;
  case 0xFFB04F: Serial.println("ST/REPT");    break;
  case 0xFF6897: Serial.println("0");    stoped(); break;
  case 0xFF30CF: Serial.println("1");    one(); break;
  case 0xFF18E7: Serial.println("2");    ; break;
  case 0xFF7A85: Serial.println("3");    break;
  case 0xFF10EF: Serial.println("4");    break;
  case 0xFF38C7: Serial.println("5");    break;
  case 0xFF5AA5: Serial.println("6");    break;
  case 0xFF42BD: Serial.println("7");    break;
  case 0xFF4AB5: Serial.println("8");    record(6000); break;
  case 0xFF52AD: Serial.println("9");    tmrpcm.play("one.wav");break;
  case 0xFFFFFFFF: Serial.println(" REPEAT");break;  
  default: 
    Serial.println(results.value);
  }
  delay(500); 
}
void loop() {
  if(irrecv.decode(&results)){
  translateIR();
  irrecv.resume();
  }
}
